//SCILAB: p51.sce
Tm=0.01; KE=0.05;
function dx=f1(t,x),dx=[0 1; 0 -1/Tm]*x+[0;1/Tm/KE], endfunction
x0=[1;10];
t0=0; t=0:0.001:0.05;
x1=ode(x0,t0,t,f1);
//-----Part 1
alpha=1.2
h1=-(1-2*alpha)/Tm; h2=(1-alpha)^2/Tm^2;
function dx=f2(t,x),dx=[-h1 1; -h2 -1/Tm]*x, endfunction
x2=ode(-x0,t0,t,f2);
//-----Part 2
alpha=1.8
h1=-(1-2*alpha)/Tm; h2=(1-alpha)^2/Tm^2;
x3=ode(-x0,t0,t,f2);
//-----
subplot(121),plot(t,180/%pi*x1(1,:))
subplot(121),plot(t,180/%pi*(x1(1,:)+x2(1,:)),'-.')
subplot(121),plot(t,180/%pi*(x1(1,:)+x3(1,:)),'--')
mtlb_grid, mtlb_axis([0 0.05 0 120])
xlabel('t'), ylabel('theta(t)')
legend(['theta';'alpha=1.2';'alpha=1.8']);
subplot(122),plot(t,x1(2,:))
subplot(122),plot(t,x1(2,:)+x2(2,:),'-.')
subplot(122),plot(t,x1(2,:)+x3(2,:),'--')
mtlb_grid, mtlb_axis([0 0.05 0 30])
xlabel('t'), ylabel('omega(t)')
legend(['omega';'alpha=1.2';'alpha=1.8']);
